From 184f5fefa2b8a752590aa5cee848f8c1b023581b Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Thu, 5 Jan 2017 09:10:30 +0100
Subject: [PATCH] WIP

---
 Makefile_upgrade.inc               |    5 +
 etc/defaults/rc.conf               |    3 -
 etc/network.subr                   |   33 +-
 etc/rc.d/network_ipv6              |    3 -
 etc/rc.d/rtadvd                    |    3 +-
 lib/libc/net/getaddrinfo.c         |   52 --
 lib/libc/net/getnameinfo.c         |    1 -
 share/man/man4/Makefile            |    2 -
 share/man/man4/faith.4             |  137 -----
 share/man/man4/inet6.4             |   13 +-
 share/man/man4/ip6.4               |    6 +-
 share/man/man5/rc.conf.5           |   10 +-
 sys/boot/dloader/loader-bootp.conf |    1 -
 sys/boot/dloader/loader.conf       |    1 -
 sys/conf/files                     |    1 -
 sys/config/LINT64                  |    3 -
 sys/config/VKERNEL64               |    1 -
 sys/config/X86_64_GENERIC          |    1 -
 sys/net/Makefile                   |    2 +-
 sys/net/faith/Makefile             |   18 -
 sys/net/faith/if_faith.c           |  361 ------------
 sys/net/faith/if_faith.h           |   44 --
 sys/net/if_types.h                 |    2 -
 sys/netinet/in.h                   |    2 -
 sys/netinet/in_pcb.c               |    6 +-
 sys/netinet/in_pcb.h               |    2 -
 sys/netinet/ip_icmp.c              |   13 -
 sys/netinet/ip_input.c             |   17 -
 sys/netinet/ip_output.c            |   10 -
 sys/netinet6/icmp6.c               |   16 -
 sys/netinet6/in6.c                 |   11 +-
 sys/netinet6/in6.h                 |    4 -
 sys/netinet6/in6_pcb.c             |    8 -
 sys/netinet6/in6_proto.c           |    4 -
 sys/netinet6/ip6_input.c           |   16 +-
 sys/netinet6/ip6_output.c          |   10 -
 sys/netinet6/ip6_var.h             |    2 -
 sys/netinet6/raw_ip6.c             |    6 -
 sys/netinet6/udp6_usrreq.c         |    6 -
 usr.sbin/Makefile                  |    1 -
 usr.sbin/faithd/Makefile           |   24 -
 usr.sbin/faithd/README             |  150 -----
 usr.sbin/faithd/faithd.8           |  428 --------------
 usr.sbin/faithd/faithd.c           |  965 ------------------------------
 usr.sbin/faithd/faithd.h           |   70 ---
 usr.sbin/faithd/ftp.c              | 1142 ------------------------------------
 usr.sbin/faithd/prefix.c           |  346 -----------
 usr.sbin/faithd/prefix.h           |   53 --
 usr.sbin/faithd/rsh.c              |  213 -------
 usr.sbin/faithd/tcp.c              |  305 ----------
 usr.sbin/faithd/test/faithd.rb     |  313 ----------
 usr.sbin/inetd/inetd.c             |   17 +-
 usr.sbin/inetd/inetd.h             |    2 -
 53 files changed, 16 insertions(+), 4849 deletions(-)
 delete mode 100644 share/man/man4/faith.4
 delete mode 100644 sys/net/faith/Makefile
 delete mode 100644 sys/net/faith/if_faith.c
 delete mode 100644 sys/net/faith/if_faith.h
 delete mode 100644 usr.sbin/faithd/Makefile
 delete mode 100644 usr.sbin/faithd/README
 delete mode 100644 usr.sbin/faithd/faithd.8
 delete mode 100644 usr.sbin/faithd/faithd.c
 delete mode 100644 usr.sbin/faithd/faithd.h
 delete mode 100644 usr.sbin/faithd/ftp.c
 delete mode 100644 usr.sbin/faithd/prefix.c
 delete mode 100644 usr.sbin/faithd/prefix.h
 delete mode 100644 usr.sbin/faithd/rsh.c
 delete mode 100644 usr.sbin/faithd/tcp.c
 delete mode 100644 usr.sbin/faithd/test/faithd.rb

diff --git a/Makefile_upgrade.inc b/Makefile_upgrade.inc
index d8f3706cb5..61fd1e72b1 100644
--- a/Makefile_upgrade.inc
+++ b/Makefile_upgrade.inc
@@ -3201,6 +3201,11 @@ TO_REMOVE+=/etc/rc.d/abi
 TO_REMOVE+=/sbin/mount_linprocfs
 TO_REMOVE+=/usr/share/man/man5/linprocfs.5.gz
 TO_REMOVE+=/usr/share/man/man8/mount_linprocfs.8.gz
+TO_REMOVE+=/boot/kernel/if_faith.ko
+TO_REMOVE+=/usr/sbin/faithd
+TO_REMOVE+=/usr/share/man/man4/faith.4.gz
+TO_REMOVE+=/usr/share/man/man4/if_faith.4.gz
+TO_REMOVE+=/usr/share/man/man8/faithd.8.gz
 
 .if !defined(WANT_INSTALLER)
 TO_REMOVE+=/usr/sbin/dfuibe_installer
diff --git a/etc/defaults/rc.conf b/etc/defaults/rc.conf
index bfa2b75013..bb8e707ec4 100644
--- a/etc/defaults/rc.conf
+++ b/etc/defaults/rc.conf
@@ -273,9 +273,6 @@ stf_interface_ipv4plen="0"	# Prefix length for 6to4 IPv4 addr,
 stf_interface_ipv6_ifid="0:0:0:1"	# IPv6 interface id for stf0.
 				# If you like, you can set "AUTO" for this.
 stf_interface_ipv6_slaid="0000"	# IPv6 Site Level Aggregator for stf0
-ipv6_faith_prefix="NO"		# Set faith prefix to enable a FAITH
-				# IPv6-to-IPv4 TCP translator.  You also need
-				# faithd(8) setup.
 ipv6_firewall_enable="NO"	# Set to YES to enable IPv6 firewall
 				# functionality
 ipv6_firewall_script="/etc/rc.firewall6" # Which script to run to set up the IPv6 firewall
diff --git a/etc/network.subr b/etc/network.subr
index ba2d5f8c7a..c03a79d0de 100644
--- a/etc/network.subr
+++ b/etc/network.subr
@@ -520,7 +520,7 @@ network6_interface_setup()
 		if [ ${rtsol_available} = yes -a ${rtsol_interface} = yes ]
 		then
 			case ${i} in
-			lo0|gif[0-9]*|stf[0-9]*|faith[0-9]*|lp[0-9]*|sl[0-9]*|tun[0-9]*)
+			lo0|gif[0-9]*|stf[0-9]*|lp[0-9]*|sl[0-9]*|tun[0-9]*)
 				;;
 			*)
 				rtsol_interfaces="${rtsol_interfaces} ${i}"
@@ -628,35 +628,6 @@ network6_static_routes_setup()
 	esac
 }
 
-# Setup faith
-network6_faith_setup()
-{
-	case ${ipv6_faith_prefix} in
-	[Nn][Oo] | '')
-		;;
-	*)
-		sysctl net.inet6.ip6.keepfaith=1
-		ifconfig faith0 create >/dev/null 2>&1
-		ifconfig faith0 up
-		for prefix in ${ipv6_faith_prefix}; do
-			prefixlen=`expr "${prefix}" : ".*/\(.*\)"`
-			case ${prefixlen} in
-			'')
-				prefixlen=96
-				;;
-			*)
-				prefix=`expr "${prefix}" : \
-					     "\(.*\)/${prefixlen}"`
-				;;
-			esac
-			route add -inet6 ${prefix} -prefixlen ${prefixlen} ::1
-			route change -inet6 ${prefix} -prefixlen ${prefixlen} \
-				-ifp faith0
-		done
-		;;
-	esac
-}
-
 # Install the "default interface" to kernel, which will be used
 # as the default route when there's no router.
 network6_default_interface_setup()
@@ -666,7 +637,7 @@ network6_default_interface_setup()
 	'')
 		for i in ${ipv6_network_interfaces}; do
 			case $i in
-			lo0|faith[0-9]*)
+			lo0)
 				continue
 				;;
 			esac
diff --git a/etc/rc.d/network_ipv6 b/etc/rc.d/network_ipv6
index b4e776503f..42a25180c5 100644
--- a/etc/rc.d/network_ipv6
+++ b/etc/rc.d/network_ipv6
@@ -107,9 +107,6 @@ network_ipv6_start()
 
 	# Setup static routes
 	network6_static_routes_setup
-
-	# Setup faith
-	network6_faith_setup
 }
 
 load_rc_config $name
diff --git a/etc/rc.d/rtadvd b/etc/rc.d/rtadvd
index eb29ade12a..d330b89daa 100644
--- a/etc/rc.d/rtadvd
+++ b/etc/rc.d/rtadvd
@@ -2,7 +2,6 @@
 #
 # $NetBSD: rtadvd,v 1.5 2002/03/22 04:34:00 thorpej Exp $
 # $FreeBSD: src/etc/rc.d/rtadvd,v 1.5 2003/01/24 00:37:52 mtm Exp $
-# $DragonFly: src/etc/rc.d/rtadvd,v 1.4 2005/11/19 21:47:32 swildner Exp $
 #
 
 # PROVIDE: rtadvd
@@ -45,7 +44,7 @@ rtadvd_precmd()
 	'')
 		for i in `ifconfig -l` ; do
 			case $i in
-			lo0|gif[0-9]*|stf[0-9]*|faith[0-9]*|lp[0-9]*|sl[0-9]*|tun[0-9]*)
+			lo0|gif[0-9]*|stf[0-9]*|lp[0-9]*|sl[0-9]*|tun[0-9]*)
 				continue
 				;;
 			*)
diff --git a/lib/libc/net/getaddrinfo.c b/lib/libc/net/getaddrinfo.c
index f64c360eab..89ed90e84f 100644
--- a/lib/libc/net/getaddrinfo.c
+++ b/lib/libc/net/getaddrinfo.c
@@ -31,8 +31,6 @@
  */
 
 /*
- * "#ifdef FAITH" part is local hack for supporting IPv4-v6 translator.
- *
  * Issues to be discussed:
  * - Return values.  There are nonstandard return values defined and used
  *   in the source code.  This is because RFC2553 is silent about which error
@@ -96,10 +94,6 @@
 #include "nscache.h"
 #endif
 
-#if defined(__KAME__) && defined(INET6)
-# define FAITH
-#endif
-
 #define SUCCESS 0
 #define ANY 0
 #define YES 1
@@ -1247,47 +1241,6 @@ get_ai(const struct addrinfo *pai, const struct afd *afd, const char *addr)
 {
 	char *p;
 	struct addrinfo *ai;
-#ifdef FAITH
-	struct in6_addr faith_prefix;
-	char *fp_str;
-	int translate = 0;
-#endif
-
-#ifdef FAITH
-	/*
-	 * Transfrom an IPv4 addr into a special IPv6 addr format for
-	 * IPv6->IPv4 translation gateway. (only TCP is supported now)
-	 *
-	 * +-----------------------------------+------------+
-	 * | faith prefix part (12 bytes)      | embedded   |
-	 * |                                   | IPv4 addr part (4 bytes)
-	 * +-----------------------------------+------------+
-	 *
-	 * faith prefix part is specified as ascii IPv6 addr format
-	 * in environmental variable GAI.
-	 * For FAITH to work correctly, routing to faith prefix must be
-	 * setup toward a machine where a FAITH daemon operates.
-	 * Also, the machine must enable some mechanizm
-	 * (e.g. faith interface hack) to divert those packet with
-	 * faith prefixed destination addr to user-land FAITH daemon.
-	 */
-	fp_str = getenv("GAI");
-	if (fp_str && inet_pton(AF_INET6, fp_str, &faith_prefix) == 1 &&
-	    afd->a_af == AF_INET && pai->ai_socktype == SOCK_STREAM) {
-		u_int32_t v4a;
-		u_int8_t v4a_top;
-
-		memcpy(&v4a, addr, sizeof v4a);
-		v4a_top = v4a >> IN_CLASSA_NSHIFT;
-		if (!IN_MULTICAST(v4a) && !IN_EXPERIMENTAL(v4a) &&
-		    v4a_top != 0 && v4a != IN_LOOPBACKNET) {
-			afd = &afdl[N_INET6];
-			memcpy(&faith_prefix.s6_addr[12], addr,
-			       sizeof(struct in_addr));
-			translate = 1;
-		}
-	}
-#endif
 
 	ai = (struct addrinfo *)malloc(sizeof(struct addrinfo)
 		+ (afd->a_socklen));
@@ -1301,11 +1254,6 @@ get_ai(const struct addrinfo *pai, const struct afd *afd, const char *addr)
 	ai->ai_addrlen = afd->a_socklen;
 	ai->ai_addr->sa_family = ai->ai_family = afd->a_af;
 	p = (char *)(void *)(ai->ai_addr);
-#ifdef FAITH
-	if (translate == 1)
-		memcpy(p + afd->a_off, &faith_prefix, (size_t)afd->a_addrlen);
-	else
-#endif
 	memcpy(p + afd->a_off, addr, (size_t)afd->a_addrlen);
 	return ai;
 }
diff --git a/lib/libc/net/getnameinfo.c b/lib/libc/net/getnameinfo.c
index a2ac5e20a6..a0bdf770f9 100644
--- a/lib/libc/net/getnameinfo.c
+++ b/lib/libc/net/getnameinfo.c
@@ -401,7 +401,6 @@ getnameinfo_link(const struct sockaddr *sa, socklen_t salen __unused,
 	/*
 	 * The following have zero-length addresses.
 	 * IFT_ATM	(net/if_atmsubr.c)
-	 * IFT_FAITH	(net/if_faith.c)
 	 * IFT_GIF	(net/if_gif.c)
 	 * IFT_LOOP	(net/if_loop.c)
 	 * IFT_PPP	(net/if_ppp.c, net/if_spppsubr.c)
diff --git a/share/man/man4/Makefile b/share/man/man4/Makefile
index 1e18b7799f..4c59ab457d 100644
--- a/share/man/man4/Makefile
+++ b/share/man/man4/Makefile
@@ -95,7 +95,6 @@ MAN=	aac.4 \
 	em.4 \
 	et.4 \
 	exca.4 \
-	faith.4 \
 	fast_ipsec.4 \
 	fd.4 \
 	fdc.4 \
@@ -439,7 +438,6 @@ MLINKS+=em.4 emx.4 \
 	em.4 if_em.4 \
 	em.4 if_emx.4
 MLINKS+=et.4 if_et.4
-MLINKS+=faith.4 if_faith.4
 MLINKS+=fd.4 stderr.4 \
 	fd.4 stdin.4 \
 	fd.4 stdout.4
diff --git a/sys/boot/dloader/loader-bootp.conf b/sys/boot/dloader/loader-bootp.conf
index 07e0f5ba36..f2141ea793 100644
--- a/sys/boot/dloader/loader-bootp.conf
+++ b/sys/boot/dloader/loader-bootp.conf
@@ -142,7 +142,6 @@ linux_load="NO"			# Linux emulation
 
 if_disc_load="NO"		# Discard device
 if_ef_load="NO"			# pseudo-device providing support for multiple ethernet frame types
-if_faith_load="NO"		# IPv6-to-IPv4 TCP relay capturing interface
 if_gif_load="NO"		# generic tunnel interface
 if_gre_load="NO"		# encapsulating network device
 if_ppp_load="NO"		# Kernel ppp
diff --git a/sys/boot/dloader/loader.conf b/sys/boot/dloader/loader.conf
index c3cbcaa9a2..c3e9a1286b 100644
--- a/sys/boot/dloader/loader.conf
+++ b/sys/boot/dloader/loader.conf
@@ -150,7 +150,6 @@ linux_load="NO"			# Linux emulation
 
 if_disc_load="NO"		# Discard device
 if_ef_load="NO"			# pseudo-device providing support for multiple ethernet frame types
-if_faith_load="NO"		# IPv6-to-IPv4 TCP relay capturing interface
 if_gif_load="NO"		# generic tunnel interface
 if_gre_load="NO"		# encapsulating network device
 if_ppp_load="NO"		# Kernel ppp
diff --git a/sys/conf/files b/sys/conf/files
index 8e9e82b1af..a7d1d9ad6a 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -1313,7 +1313,6 @@ net/if_clone.c			standard
 net/if_poll.c			optional ifpoll_enable
 net/disc/if_disc.c		optional disc
 net/if_ethersubr.c		optional ether
-net/faith/if_faith.c		optional faith
 net/gif/if_gif.c		optional gif
 net/gre/if_gre.c		optional gre inet
 net/lagg/ieee8023ad_lacp.c	optional lagg
diff --git a/sys/config/LINT64 b/sys/config/LINT64
index f9f612b45c..67586ecc71 100644
--- a/sys/config/LINT64
+++ b/sys/config/LINT64
@@ -320,8 +320,6 @@ device		mn	# Munich32x/Falc54 Nx64kbit/sec cards.
 #  IPv6 over IPv6 tunneling.
 #  The `gre' device implements two types of IP4 over IP4 tunneling:
 #  GRE and MOBILE, as specified in the RFC1701 and RFC2004.
-#  The `faith' pseudo-device captures packets sent to it and diverts them
-#  to the IPv4/IPv6 translation daemon.
 #  The `stf' device implements 6to4 encapsulation.
 #  The `ef' pseudo-device provides support for multiple ethernet frame types
 #  specified via ETHER_* options. See ef(4) for details.
@@ -350,7 +348,6 @@ options 	PPP_FILTER		#enable bpf filtering (needs bpf)
 
 # for IPv6
 pseudo-device	gif			#IPv6 and IPv4 tunneling
-pseudo-device	faith	1		#for IPv6 and IPv4 translation
 pseudo-device	stf			#6to4 IPv6 over IPv4 encapsulation
 
 #
diff --git a/sys/config/VKERNEL64 b/sys/config/VKERNEL64
index cec557f71e..ada9b00449 100644
--- a/sys/config/VKERNEL64
+++ b/sys/config/VKERNEL64
@@ -75,7 +75,6 @@ pseudo-device	pty		# Pseudo-ttys (telnet etc)
 pseudo-device	md		# Memory "disks"
 pseudo-device	vn		# File image "disks"
 pseudo-device	gif		# IPv6 and IPv4 tunneling
-pseudo-device	faith	1	# IPv6-to-IPv4 relaying (translation)
 
 #pseudo-device	carp
 
diff --git a/sys/config/X86_64_GENERIC b/sys/config/X86_64_GENERIC
index c12686bd56..0e5840dc75 100644
--- a/sys/config/X86_64_GENERIC
+++ b/sys/config/X86_64_GENERIC
@@ -287,7 +287,6 @@ pseudo-device	pty		# Pseudo-ttys (telnet etc)
 pseudo-device	md		# Memory "disks"
 pseudo-device	vn		# File image "disks"
 pseudo-device	gif		# IPv6 and IPv4 tunneling
-pseudo-device	faith	1	# IPv6-to-IPv4 relaying (translation)
 pseudo-device   lagg
 
 # CARP support
diff --git a/sys/net/Makefile b/sys/net/Makefile
index caec824eef..4b117b1c4f 100644
--- a/sys/net/Makefile
+++ b/sys/net/Makefile
@@ -1,4 +1,4 @@
-SUBDIR=accf_data accf_http disc faith gif gre sl stf tap tun \
+SUBDIR=accf_data accf_http disc gif gre sl stf tap tun \
 	vlan zlib bridge lagg libalias dummynet ipfw \
 	dummynet3 ipfw3 ipfw3_basic ipfw3_nat ipfw3_layer2 ipfw3_layer4 \
 	ip6fw ip_mroute sppp ppp_layer pf
diff --git a/sys/net/if_types.h b/sys/net/if_types.h
index ebaa01bdd5..c7fdd7d853 100644
--- a/sys/net/if_types.h
+++ b/sys/net/if_types.h
@@ -28,7 +28,6 @@
  *
  *	@(#)if_types.h	8.3 (Berkeley) 4/28/95
  * $FreeBSD: src/sys/net/if_types.h,v 1.8.2.4 2002/12/23 23:02:21 kbyanc Exp $
- * $DragonFly: src/sys/net/if_types.h,v 1.6 2007/08/16 20:03:57 dillon Exp $
  * $NetBSD: if_types.h,v 1.16 2000/04/19 06:30:53 itojun Exp $
  */
 
@@ -244,7 +243,6 @@
 /* not based on IANA assignments */
 #define	IFT_GIF		0xf0
 #define	IFT_PVC		0xf1
-#define	IFT_FAITH	0xf2
 #define	IFT_STF		0xf3
 #define	IFT_ENC		0xf4
 #define	IFT_PFLOG	0xf5		/* Packet filter logging */
diff --git a/sys/netinet/in.h b/sys/netinet/in.h
index 611b3c63ed..6c32a5efbb 100644
--- a/sys/netinet/in.h
+++ b/sys/netinet/in.h
@@ -348,7 +348,6 @@ struct sockaddr_in {
 #define	IP_RECVIF		20   /* bool; receive reception if w/dgram */
 /* for IPSEC */
 #define	IP_IPSEC_POLICY		21   /* int; set/get security policy */
-#define	IP_FAITH		22   /* bool; accept FAITH'ed connections */
 
 #define	IP_FW_X			49   /* ipfw2 firewall */
 #define	IP_FW_ADD		50   /* add a firewall rule to chain */
@@ -487,7 +486,6 @@ struct ip_mreq {
 #define	IPCTL_STATS		12	/* ipstat structure */
 #define	IPCTL_ACCEPTSOURCEROUTE	13	/* may accept source routed packets */
 #define	IPCTL_FASTFORWARDING	14	/* use fast IP forwarding code */
-#define	IPCTL_KEEPFAITH		15	/* FAITH IPv4->IPv6 translater ctl */
 #define	IPCTL_GIF_TTL		16	/* default TTL for gif encap packet */
 #define	IPCTL_MAXID		17
 
diff --git a/sys/netinet/in_pcb.c b/sys/netinet/in_pcb.c
index 7b5833c8d3..f841fe0580 100644
--- a/sys/netinet/in_pcb.c
+++ b/sys/netinet/in_pcb.c
@@ -1590,8 +1590,7 @@ in_pcblookup_pkthash(struct inpcbinfo *pcbinfo, struct in_addr faddr,
 		 * Check local group first
 		 */
 		if (pcbinfo->localgrphashbase != NULL &&
-		    m != NULL && (m->m_flags & M_HASH) &&
-		    !(ifp && ifp->if_type == IFT_FAITH)) {
+		    m != NULL && (m->m_flags & M_HASH)) {
 			inp = inp_localgroup_lookup(pcbinfo,
 			    laddr, lport, m->m_pkthdr.hash);
 			if (inp != NULL) {
@@ -1633,9 +1632,6 @@ in_pcblookup_pkthash(struct inpcbinfo *pcbinfo, struct in_addr faddr,
 						continue;
 			}
 			if (inp->inp_lport == lport) {
-				if (ifp && ifp->if_type == IFT_FAITH &&
-				    !(inp->inp_flags & INP_FAITH))
-					continue;
 				if (inp->inp_laddr.s_addr == laddr.s_addr) {
 					if (cred != NULL && jailed(cred)) {
 						jinp = inp;
diff --git a/sys/netinet/in_pcb.h b/sys/netinet/in_pcb.h
index fa198b0504..07f017e031 100644
--- a/sys/netinet/in_pcb.h
+++ b/sys/netinet/in_pcb.h
@@ -336,7 +336,6 @@ struct inpcbinfo {		/* XXX documentation, prefixes */
 #define	INP_ANONPORT		0x40	/* port chosen for user */
 #define	INP_RECVIF		0x80	/* receive incoming interface */
 #define	INP_MTUDISC		0x100	/* user can do MTU discovery */
-#define	INP_FAITH		0x200	/* accept FAITH'ed connections */
 #define	INP_WILDCARD		0x400	/* wildcard match */
 #define INP_FLAG_PROTO2		0x800	/* protocol specific */
 #define	INP_CONNECTED		0x1000	/* exact match */
@@ -378,7 +377,6 @@ struct inpcbinfo {		/* XXX documentation, prefixes */
 #define	IN6P_ANONPORT		INP_ANONPORT
 #define	IN6P_RECVIF		INP_RECVIF
 #define	IN6P_MTUDISC		INP_MTUDISC
-#define	IN6P_FAITH		INP_FAITH
 #define	IN6P_CONTROLOPTS INP_CONTROLOPTS
 	/*
 	 * socket AF version is {newer than,or include}
diff --git a/sys/netinet/ip_icmp.c b/sys/netinet/ip_icmp.c
index d49609e536..9af5b93c04 100644
--- a/sys/netinet/ip_icmp.c
+++ b/sys/netinet/ip_icmp.c
@@ -639,19 +639,6 @@ icmp_input(struct mbuf **mp, int *offp, int proto)
 	}
 	icp = (struct icmp *)((caddr_t)ip + hlen);
 
-	if (m->m_pkthdr.rcvif && m->m_pkthdr.rcvif->if_type == IFT_FAITH) {
-		/*
-		 * Deliver very specific ICMP type only.
-		 */
-		switch (icp->icmp_type) {
-		case ICMP_UNREACH:
-		case ICMP_TIMXCEED:
-			break;
-		default:
-			goto freeit;
-		}
-	}
-
 #ifdef ICMPPRINTFS
 	if (icmpprintfs)
 		kprintf("icmp_input, type %d code %d\n", icp->icmp_type,
diff --git a/sys/netinet/ip_input.c b/sys/netinet/ip_input.c
index d7532ca28a..f6b60dbcbe 100644
--- a/sys/netinet/ip_input.c
+++ b/sys/netinet/ip_input.c
@@ -155,11 +155,6 @@ SYSCTL_INT(_net_inet_ip, IPCTL_ACCEPTSOURCEROUTE, accept_sourceroute,
     CTLFLAG_RW, &ip_acceptsourceroute, 0,
     "Enable accepting source routed IP packets");
 
-static int ip_keepfaith = 0;
-SYSCTL_INT(_net_inet_ip, IPCTL_KEEPFAITH, keepfaith, CTLFLAG_RW,
-    &ip_keepfaith, 0,
-    "Enable packet capture for FAITH IPv4->IPv6 translator daemon");
-
 static int maxnipq;
 SYSCTL_INT(_net_inet_ip, OID_AUTO, maxfragpackets, CTLFLAG_RW,
     &maxnipq, 0,
@@ -801,18 +796,6 @@ pass:
 		goto ours;
 
 	/*
-	 * FAITH(Firewall Aided Internet Translator)
-	 */
-	if (m->m_pkthdr.rcvif && m->m_pkthdr.rcvif->if_type == IFT_FAITH) {
-		if (ip_keepfaith) {
-			if (ip->ip_p == IPPROTO_TCP || ip->ip_p == IPPROTO_ICMP)
-				goto ours;
-		}
-		m_freem(m);
-		return;
-	}
-
-	/*
 	 * Not for us; forward if possible and desirable.
 	 */
 	if (!ipforwarding) {
diff --git a/sys/netinet/ip_output.c b/sys/netinet/ip_output.c
index 00d8717144..16cc060082 100644
--- a/sys/netinet/ip_output.c
+++ b/sys/netinet/ip_output.c
@@ -1418,7 +1418,6 @@ ip_ctloutput(netmsg_t msg)
 		case IP_RECVDSTADDR:
 		case IP_RECVIF:
 		case IP_RECVTTL:
-		case IP_FAITH:
 			error = soopt_to_kbuf(sopt, &optval, sizeof optval,
 					     sizeof optval);
 			if (error)
@@ -1462,10 +1461,6 @@ ip_ctloutput(netmsg_t msg)
 			case IP_RECVTTL:
 				OPTSET(INP_RECVTTL);
 				break;
-
-			case IP_FAITH:
-				OPTSET(INP_FAITH);
-				break;
 			}
 			break;
 #undef OPTSET
@@ -1557,7 +1552,6 @@ ip_ctloutput(netmsg_t msg)
 		case IP_RECVTTL:
 		case IP_RECVIF:
 		case IP_PORTRANGE:
-		case IP_FAITH:
 			switch (sopt->sopt_name) {
 
 			case IP_TOS:
@@ -1601,10 +1595,6 @@ ip_ctloutput(netmsg_t msg)
 				else
 					optval = 0;
 				break;
-
-			case IP_FAITH:
-				optval = OPTBIT(INP_FAITH);
-				break;
 			}
 			soopt_from_kbuf(sopt, &optval, sizeof optval);
 			break;
diff --git a/sys/netinet6/icmp6.c b/sys/netinet6/icmp6.c
index dff8cc1cd4..bae0597f3b 100644
--- a/sys/netinet6/icmp6.c
+++ b/sys/netinet6/icmp6.c
@@ -435,22 +435,6 @@ icmp6_input(struct mbuf **mp, int *offp, int proto)
 		goto freeit;
 	}
 
-	if (faithprefix_p != NULL && (*faithprefix_p)(&ip6->ip6_dst)) {
-		/*
-		 * Deliver very specific ICMP6 type only.
-		 * This is important to deilver TOOBIG.  Otherwise PMTUD
-		 * will not work.
-		 */
-		switch (icmp6->icmp6_type) {
-		case ICMP6_DST_UNREACH:
-		case ICMP6_PACKET_TOO_BIG:
-		case ICMP6_TIME_EXCEEDED:
-			break;
-		default:
-			goto freeit;
-		}
-	}
-
 	icmp6stat.icp6s_inhist[icmp6->icmp6_type]++;
 	icmp6_ifstat_inc(m->m_pkthdr.rcvif, ifs6_in_msg);
 	if (icmp6->icmp6_type < ICMP6_INFOMSG_MASK)
diff --git a/sys/netinet6/in6.c b/sys/netinet6/in6.c
index b67e309604..fd11d5e2a3 100644
--- a/sys/netinet6/in6.c
+++ b/sys/netinet6/in6.c
@@ -141,8 +141,6 @@ static int	in6_control_internal(u_long, caddr_t, struct ifnet *,
 
 struct in6_multihead in6_multihead;	/* XXX BSS initialization */
 
-int	(*faithprefix_p)(struct in6_addr *);
-
 /*
  * Subroutine for in6_ifaddloop() and in6_ifremloop().
  * This routine does actual work.
@@ -2437,15 +2435,8 @@ in6if_do_dad(struct ifnet *ifp)
 	switch (ifp->if_type) {
 #ifdef IFT_DUMMY
 	case IFT_DUMMY:
-#endif
-	case IFT_FAITH:
-		/*
-		 * These interfaces do not have the IFF_LOOPBACK flag,
-		 * but loop packets back.  We do not have to do DAD on such
-		 * interfaces.  We should even omit it, because loop-backed
-		 * NS would confuse the DAD procedure.
-		 */
 		return (0);
+#endif
 	default:
 		/*
 		 * Our DAD routine requires the interface up and running.
diff --git a/sys/netinet6/in6.h b/sys/netinet6/in6.h
index 6079d649ae..546d67f68c 100644
--- a/sys/netinet6/in6.h
+++ b/sys/netinet6/in6.h
@@ -429,7 +429,6 @@ struct route_in6 {
 #if 1 /* IPSEC */
 #define IPV6_IPSEC_POLICY	28 /* struct; get/set security policy */
 #endif
-#define IPV6_FAITH		29 /* bool; accept FAITH'ed connections */
 
 #if 1 /* IPV6FIREWALL */
 #define IPV6_FW_ADD		30 /* add a firewall rule to chain */
@@ -557,7 +556,6 @@ struct ip6_mtuinfo {
 #define IPV6CTL_SOURCECHECK	10	/* verify source route and intf */
 #define IPV6CTL_SOURCECHECK_LOGINT 11	/* minimume logging interval */
 #define IPV6CTL_ACCEPT_RTADV	12
-#define IPV6CTL_KEEPFAITH	13
 #define IPV6CTL_LOG_INTERVAL	14
 #define IPV6CTL_HDRNESTLIMIT	15
 #define IPV6CTL_DAD_COUNT	16
@@ -621,8 +619,6 @@ void	addrsel_policy_init (void);
 #define	satosin6(sa)	((struct sockaddr_in6 *)(sa))
 #define	sin6tosa(sin6)	((struct sockaddr *)(sin6))
 #define	ifatoia6(ifa)	((struct in6_ifaddr *)(ifa))
-
-extern int (*faithprefix_p)(struct in6_addr *);
 #endif /* _KERNEL */
 
 #include <sys/cdefs.h>		/* for __BEGIN_DECLS and __END_DECLS */
diff --git a/sys/netinet6/in6_pcb.c b/sys/netinet6/in6_pcb.c
index 92a07d47b8..8d692746d3 100644
--- a/sys/netinet6/in6_pcb.c
+++ b/sys/netinet6/in6_pcb.c
@@ -835,12 +835,6 @@ in6_pcblookup_hash(struct inpcbinfo *pcbinfo, struct in6_addr *faddr,
 	struct inpcb *inp;
 	struct inpcb *jinp = NULL;
 	u_short fport = fport_arg, lport = lport_arg;
-	int faith;
-
-	if (faithprefix_p != NULL)
-		faith = (*faithprefix_p)(laddr);
-	else
-		faith = 0;
 
 	/*
 	 * First look for an exact match.
@@ -916,8 +910,6 @@ in6_pcblookup_hash(struct inpcbinfo *pcbinfo, struct in6_addr *faddr,
 			}
 			if (IN6_IS_ADDR_UNSPECIFIED(&inp->in6p_faddr) &&
 			    inp->inp_lport == lport) {
-				if (faith && (inp->inp_flags & INP_FAITH) == 0)
-					continue;
 				if (IN6_ARE_ADDR_EQUAL(&inp->in6p_laddr,
 						       laddr)) {
 					if (cred != NULL && jailed(cred)) {
diff --git a/sys/netinet6/in6_proto.c b/sys/netinet6/in6_proto.c
index 9846922faf..e24a65a6c0 100644
--- a/sys/netinet6/in6_proto.c
+++ b/sys/netinet6/in6_proto.c
@@ -434,7 +434,6 @@ int	ip6_rr_prune = 5;	/* router renumbering prefix
 				 * walk list every 5 sec. */
 
 u_int32_t ip6_id = 0UL;
-int	ip6_keepfaith = 0;
 time_t	ip6_log_time = (time_t)0L;
 
 /* icmp6 */
@@ -534,9 +533,6 @@ SYSCTL_INT(_net_inet6_ip6, IPV6CTL_MAXFRAGPACKETS, maxfragpackets,
     CTLFLAG_RW, &ip6_maxfragpackets, 0, "Maximum packets in reassembly queue");
 SYSCTL_INT(_net_inet6_ip6, IPV6CTL_ACCEPT_RTADV, accept_rtadv,
     CTLFLAG_RW, &ip6_accept_rtadv, 0, "Acts as a host not a router");
-SYSCTL_INT(_net_inet6_ip6, IPV6CTL_KEEPFAITH,
-    keepfaith, CTLFLAG_RW, &ip6_keepfaith, 0,
-    "Enable packet capture for FAITH IPv4->IPv6 translator daemon");
 SYSCTL_INT(_net_inet6_ip6, IPV6CTL_LOG_INTERVAL,
 	log_interval, CTLFLAG_RW,	&ip6_log_interval,	0, "");
 SYSCTL_INT(_net_inet6_ip6, IPV6CTL_HDRNESTLIMIT, hdrnestlimit, CTLFLAG_RW,
diff --git a/sys/netinet6/ip6_input.c b/sys/netinet6/ip6_input.c
index e2dd4d45cd..83466f4a56 100644
--- a/sys/netinet6/ip6_input.c
+++ b/sys/netinet6/ip6_input.c
@@ -541,19 +541,6 @@ ip6_input(netmsg_t msg)
 	}
 
 	/*
-	 * FAITH (Firewall Aided Internet Translator)
-	 */
-	if (ip6_keepfaith) {
-		if (ip6_forward_rt.ro_rt && ip6_forward_rt.ro_rt->rt_ifp
-		 && ip6_forward_rt.ro_rt->rt_ifp->if_type == IFT_FAITH) {
-			/* XXX do we need more sanity checks? */
-			ours = 1;
-			deliverifp = ip6_forward_rt.ro_rt->rt_ifp; /* faith */
-			goto hbhcheck;
-		}
-	}
-
-	/*
 	 * Now there is no reason to process the packet if it's not our own
 	 * and we're not a router.
 	 */
@@ -567,8 +554,7 @@ hbhcheck:
 	/*
 	 * record address information into m_aux, if we don't have one yet.
 	 * note that we are unable to record it, if the address is not listed
-	 * as our interface address (e.g. multicast addresses, addresses
-	 * within FAITH prefixes and such).
+	 * as our interface address (e.g. multicast addresses and such).
 	 */
 	if (deliverifp && !ip6_getdstifaddr(m)) {
 		struct in6_ifaddr *ia6;
diff --git a/sys/netinet6/ip6_output.c b/sys/netinet6/ip6_output.c
index f42d86d252..fdb6288320 100644
--- a/sys/netinet6/ip6_output.c
+++ b/sys/netinet6/ip6_output.c
@@ -1439,7 +1439,6 @@ ip6_ctloutput(struct socket *so, struct sockopt *sopt)
 			case IPV6_HOPLIMIT:
 			/* FALLTHROUGH */
 			case IPV6_UNICAST_HOPS:
-			case IPV6_FAITH:
 
 			case IPV6_V6ONLY:
 				if (optlen != sizeof(int)) {
@@ -1574,10 +1573,6 @@ do { \
 					OPTSET(IN6P_AUTOFLOWLABEL);
 					break;
 
-				case IPV6_FAITH:
-					OPTSET(IN6P_FAITH);
-					break;
-
 				case IPV6_V6ONLY:
 					/*
 					 * make setsockopt(IPV6_V6ONLY)
@@ -1837,7 +1832,6 @@ do { \
 			case IPV6_RECVPATHMTU:
 			case IPV6_RECVTCLASS:
 			case IPV6_AUTOFLOWLABEL:
-			case IPV6_FAITH:
 			case IPV6_V6ONLY:
 			case IPV6_PORTRANGE:
 				switch (optname) {
@@ -1883,10 +1877,6 @@ do { \
 					optval = in6p->in6p_hops;
 					break;
 
-				case IPV6_FAITH:
-					optval = OPTBIT(IN6P_FAITH);
-					break;
-
 				case IPV6_V6ONLY:
 					optval = 1;
 					break;
diff --git a/sys/netinet6/ip6_var.h b/sys/netinet6/ip6_var.h
index 5520bed8f5..01df745ca5 100644
--- a/sys/netinet6/ip6_var.h
+++ b/sys/netinet6/ip6_var.h
@@ -1,5 +1,4 @@
 /*	$FreeBSD: src/sys/netinet6/ip6_var.h,v 1.2.2.4 2003/01/23 21:06:47 sam Exp $	*/
-/*	$DragonFly: src/sys/netinet6/ip6_var.h,v 1.13 2008/09/04 09:08:22 hasso Exp $	*/
 /*	$KAME: ip6_var.h,v 1.62 2001/05/03 14:51:48 itojun Exp $	*/
 
 /*
@@ -310,7 +309,6 @@ extern int	ip6_maxfrags;	/* Maximum fragments in reassembly queue */
 extern int	ip6_sourcecheck;	/* Verify source interface */
 extern int	ip6_sourcecheck_interval; /* Interval between log messages */
 extern int	ip6_accept_rtadv;	/* Acts as a host not a router */
-extern int	ip6_keepfaith;		/* Firewall Aided Internet Translator */
 extern int	ip6_log_interval;
 extern time_t	ip6_log_time;
 extern int	ip6_hdrnestlimit; /* upper limit of # of extension headers */
diff --git a/sys/netinet6/raw_ip6.c b/sys/netinet6/raw_ip6.c
index fdfee292c0..c890589abb 100644
--- a/sys/netinet6/raw_ip6.c
+++ b/sys/netinet6/raw_ip6.c
@@ -141,12 +141,6 @@ rip6_input(struct mbuf **mp, int *offp, int proto)
 
 	rip6stat.rip6s_ipackets++;
 
-	if (faithprefix_p != NULL && (*faithprefix_p)(&ip6->ip6_dst)) {
-		/* XXX send icmp6 host/port unreach? */
-		m_freem(m);
-		return IPPROTO_DONE;
-	}
-
 	init_sin6(&rip6src, m); /* general init */
 
 	LIST_FOREACH(in6p, &ripcbinfo.pcblisthead, inp_list) {
diff --git a/sys/netinet6/udp6_usrreq.c b/sys/netinet6/udp6_usrreq.c
index 95d219e845..103e0f49c6 100644
--- a/sys/netinet6/udp6_usrreq.c
+++ b/sys/netinet6/udp6_usrreq.c
@@ -159,12 +159,6 @@ udp6_input(struct mbuf **mp, int *offp, int proto)
 
 	ip6 = mtod(m, struct ip6_hdr *);
 
-	if (faithprefix_p != NULL && (*faithprefix_p)(&ip6->ip6_dst)) {
-		/* XXX send icmp6 host/port unreach? */
-		m_freem(m);
-		return IPPROTO_DONE;
-	}
-
 	udp_stat.udps_ipackets++;
 
 	plen = ntohs(ip6->ip6_plen) - off + sizeof(*ip6);
diff --git a/usr.sbin/Makefile b/usr.sbin/Makefile
index 8169e1eb0b..b0069daa8a 100644
--- a/usr.sbin/Makefile
+++ b/usr.sbin/Makefile
@@ -33,7 +33,6 @@ SUBDIR= 802_11 \
 	dntpd \
 	edquota \
 	efivar \
-	faithd \
 	fdcontrol \
 	fdformat \
 	fdwrite \
diff --git a/usr.sbin/inetd/inetd.c b/usr.sbin/inetd/inetd.c
index 4cf97cc6db..69f65d88a3 100644
--- a/usr.sbin/inetd/inetd.c
+++ b/usr.sbin/inetd/inetd.c
@@ -58,7 +58,7 @@
  *					or name a tcpmux service 
  *					or specify a unix domain socket
  *	socket type			stream/dgram/raw/rdm/seqpacket
- *	protocol			tcp[4][6][/faith,ttcp], udp[4][6], unix
+ *	protocol			tcp[4][6][/ttcp], udp[4][6], unix
  *	wait/nowait			single-threaded/multi-threaded
  *	user				user to run daemon as
  *	server program			full path name
@@ -1230,14 +1230,6 @@ setsockopt(fd, SOL_SOCKET, opt, (char *)&on, sizeof (on))
 		if (setsockopt(sep->se_fd, IPPROTO_TCP, TCP_NOPUSH,
 		    (char *)&on, sizeof (on)) < 0)
 			syslog(LOG_ERR, "setsockopt (TCP_NOPUSH): %m");
-#ifdef IPV6_FAITH
-	if (sep->se_type == FAITH_TYPE) {
-		if (setsockopt(sep->se_fd, IPPROTO_IPV6, IPV6_FAITH, &on,
-				sizeof(on)) < 0) {
-			syslog(LOG_ERR, "setsockopt (IPV6_FAITH): %m");
-		}
-	}
-#endif
 #ifdef IPSEC
 	ipsecsetup(sep);
 #endif
@@ -1654,15 +1646,8 @@ more:
 		if (arg != NULL) {
 			if (strcmp(arg, "ttcp") == 0)
 				sep->se_type = TTCP_TYPE;
-			else if (strcmp(arg, "faith") == 0)
-				sep->se_type = FAITH_TYPE;
 		}
 	} else {
-		if (sep->se_type == NORM_TYPE &&
-		    strncmp(arg, "faith/", 6) == 0) {
-			arg += 6;
-			sep->se_type = FAITH_TYPE;
-		}
 		sep->se_proto = newstr(arg);
 	}
         if (strncmp(sep->se_proto, "rpc/", 4) == 0) {
diff --git a/usr.sbin/inetd/inetd.h b/usr.sbin/inetd/inetd.h
index e98952374b..cb6138cae6 100644
--- a/usr.sbin/inetd/inetd.h
+++ b/usr.sbin/inetd/inetd.h
@@ -27,7 +27,6 @@
  * SUCH DAMAGE.
  *
  * $FreeBSD: src/usr.sbin/inetd/inetd.h,v 1.4.2.4 2002/08/21 10:00:24 ume Exp $
- * $DragonFly: src/usr.sbin/inetd/inetd.h,v 1.3 2003/11/03 19:31:37 eirikn Exp $
  */
 
 #include <sys/time.h>
@@ -46,7 +45,6 @@
 #define MUX_TYPE	1
 #define MUXPLUS_TYPE	2
 #define TTCP_TYPE	3
-#define FAITH_TYPE	4
 #define ISMUX(sep)	(((sep)->se_type == MUX_TYPE) || \
 			 ((sep)->se_type == MUXPLUS_TYPE))
 #define ISMUXPLUS(sep)	((sep)->se_type == MUXPLUS_TYPE)
-- 
2.11.0

